properties([
    [$class: 'ParametersDefinitionProperty',
    parameterDefinitions: [
        [$class: 'StringParameterDefinition', name: 'RELEASE_VERSION', defaultValue: '1.0.0'],
        [$class: 'ChoiceParameter', 
            choiceType: 'PT_SINGLE_SELECT', 
            description: 'Select the Env Name from the Dropdown List', 
            filterLength: 1, 
            filterable: true, 
            name: 'Env', 
            randomName: 'choice-parameter-5631314439613978', 
            script: [
                $class: 'GroovyScript', 
                fallbackScript: [
                    classpath: [], 
                    sandbox: false, 
                    script: 
                        'return[\'Could not get Env\']'
                ], 
                script: [
                    classpath: [], 
                    sandbox: false, 
                    script: 
                        'return["Dev","QA","Stage","Prod","PreProd"]'
                ]
            ]
        ], 
        [$class: 'CascadeChoiceParameter', 
            choiceType: 'PT_MULTI_SELECT', 
            description: 'Select the Server from the Dropdown List', 
            filterable: false, 
            name: 'Server', 
            randomName: 'choice-parameter-5631314456178619', 
            referencedParameters: 'Env', 
            script: [
                $class: 'GroovyScript', 
                fallbackScript: [
                    classpath: [], 
                    sandbox: false, 
                    script: 
                        'return[\'Could not get Environment from Env Param\']'
                ], 
                script: [
                    classpath: [], 
                    sandbox: false, 
                    script: 
                        ''' if (Env.equals("Dev")){
                                return["devaaa001","devaaa002","devbbb001","devbbb002","devccc001","devccc002"]
                            }
                            else if(Env.equals("QA")){
                                return["qaaaa001","qabbb002","qaccc003"]
                            }
                            else if(Env.equals("Stage")){
                                return["staaa001","stbbb002","stccc003"]
                            }
                            else if(Env.equals("Prod")){
                                return["praaa001","prbbb002","prccc003"]
                            }
                        '''
                ]
            ]
        ],
        [$class: 'CascadeChoiceParameter', choiceType: 'PT_RADIO', description: 'Clean workspace ?', 
            name: 'clean', 
            script: 
            [$class: 'GroovyScript',
                script: [
                    script: " return ['Yes:selected', 'No'] "
                ]
            ]
        ],
        [$class: 'CascadeChoiceParameter', choiceType: 'PT_CHECKBOX', description: 'Trace Level ?', 
            name: 'verbose', 
            script: 
            [$class: 'GroovyScript',
               sandbox: true,
               script: [
                    script: " return ['Debug', 'Warning:selected', 'Info:selected:disabled'] "
                ]
            ]
        ],
        [$class: 'DynamicReferenceParameter', 
            choiceType: 'ET_FORMATTED_HTML', 
            description: 'These are the details in HTML format', 
            name: 'DetailsInHTML', 
            omitValueField: false, 
            randomName: 'choice-parameter-5633384460832175', 
            referencedParameters: 'Env, Server',
            script: 
            [$class: 'GroovyScript',
                sandbox: true,
                script: [
                    script: """
                        return "<b>Env:"+Env+" Server:"+Server+"</b>" 
                    """
                ]
            ]
        ]
    ]    ]
])

node {
    stage ("Check Parmeters") {
        script{
            echo "Env = ${params.Env} Server = ${params.Server}"
            if (params.Server.equals("Could not get Environment from Env Param")) {
                echo "Must be the first build after Pipeline deployment.  Aborting the build"
                currentBuild.result = 'ABORTED'
                return
            }
            if (params.Server.equals("")) {
                echo "Server not set.  Aborting the build"
                currentBuild.result = 'ABORTED'
                return
            }
            echo "Crossed param validation"
        } 
    }
    stage('Build') { 
        sh label: 'Display the values of environment variables', script: 'printenv'
    }
}
